class aes::opendsa {

  $opendsa_user = opendsa
  $opendsa_group = "${opendsa_user}"
  $opendsa_home = "/srv/${opendsa_user}"
  $opendsa_service = "${opendsa_user}"

  user { "${opendsa_user}" :
    ensure => present,
    home => "${opendsa_home}",
    comment => 'OpenDSA server',
    managehome => false,
    membership => inclusive,
    system => true,
  # Do we need login shell. YES
    shell => '/bin/bash',
  }

  file { "${opendsa_home}":
    ensure => directory,
    owner  => "${opendsa_user}",
    group  => "${opendsa_group}",
    mode => '0755',
  }

  file { "${opendsa_home}/.ssh":
    ensure => directory,
    recurse => true,
  # Is modes copied correctly by "recurse" option above? NO, but works
  # chmod 0700 .ssh/id_rsa
  # chmod 0744 .ssh/id_rsa.pub .ssh/known_hosts
    purge => true,
    force => true,
    owner  => "${opendsa_user}",
    group  => "${opendsa_group}",
    mode => '0700',
    source => "puppet:///modules/${module_name}/opendsa/.ssh",
  }

  exec { '/usr/bin/git clone --single-branch --branch exam git@gitlab.ida.liu.se:filst04/OpenDSA.git' : 
    cwd => "${opendsa_home}",
    creates => "${opendsa_home}/OpenDSA",
    user => "${opendsa_user}",
    group => "${opendsa_group}",
  }

 # Will this work? DANGEROUS, need service restart! Not needed.
  # exec { '/usr/bin/git pull' : 
  #   cwd => "${opendsa_home}/OpenDSA",
  #   onlyif => "/bin/test -d ${opendsa_home}/OpenDSA/.git",
  #   user => "${opendsa_user}",
  #   group => "${opendsa_group}",
  # }

 # Install python packets. Can this be run several times safely? (Idempotent?) YES
  exec { '/usr/bin/python3 -m pip install --user -r OpenDSA/server/requirements.txt' : 
    cwd => "${opendsa_home}",
    user => "${opendsa_user}",
    group => "${opendsa_group}",
  }

  file { "${opendsa_home}/manage.sh":
    ensure => present,
    owner  => "${opendsa_user}",
    group  => "${opendsa_group}",
    mode => '0751',
    source => "puppet:///modules/${module_name}/opendsa/manage.sh",
  }

  exec { "${opendsa_home}/OpenDSA/server/main.py init_db" : 
    cwd => "${opendsa_home}",
    creates => "${opendsa_home}/OpenDSA/server/openDSA.db",
    user => "${opendsa_user}",
    group => "${opendsa_group}",
  }

  file { "/etc/systemd/system/${opendsa_service}.service":
    ensure => present,
    owner  => root,
    group  => root,
    mode => '0644',
    source => "puppet:///modules/${module_name}/opendsa/opendsa.service",
  }

 # Do we need port 12000 open? NO
  service { "${opendsa_service}" : 
    ensure => "running",
  }

  # Ändra TDDD86-raden i rules.d/opendsa till "TDDD86[AB]_191219"

}
